Attribute VB_Name = "mdlFloydSteinberg"
'Floyd Steinberg Filter Module

Option Explicit
Public WorkFilterG As Boolean
Public Enum iFilterFS
    iFLOYDSTEINBERG = 21
End Enum
Public Declare Function GetDIBits Lib "gdi32" (ByVal aHDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long
Public Declare Function LoadImage Lib "user32" Alias "LoadImageA" (ByVal hInst As Long, ByVal lpsz As String, ByVal un1 As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal un2 As Long) As Long
Public Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Public Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Public Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Public Declare Function SetDIBits Lib "gdi32" (ByVal hdc As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDst As Any, pSrc As Any, ByVal ByteLen As Long)
'-------------------------------------------Private var
Private Const BI_RGB = 0&
Private Const DIB_RGB_COLORS = 0&
Private Const LR_LOADFROMFILE = &H10
Private Const IMAGE_BITMAP = 0&

Private iDATA() As Byte           'holds bitmap data
Private bDATA() As Byte           'holds bitmap backup
Private PicInfo As BITMAP         'bitmap info structure
Private DIBInfo As BITMAPINFO     'Device Ind. Bitmap info structure
Private mProgress As Long         '% filter progress
Private Speed(0 To 765) As Long   'Speed up values

Private Type BITMAP
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type

Private Type BITMAPINFOHEADER   '40 bytes
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type

Private Type RGBQUAD
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbReserved As Byte
End Type

Private Type BITMAPINFO
    bmiHeader As BITMAPINFOHEADER
    bmiColors As RGBQUAD
End Type

Public Sub FloydSteinberg(pic As PictureBox)
'Run Filter function
    Call FilterBW(pic.Image, 15, mProgress)
    'Make graphics persistent
    pic.Picture = pic.Image
    'Check if picture loaded...
    '  If pic.Picture <> 0 Then
    '    'Copy main picturebox to back buffer
    '    pic.PaintPicture pic.Picture, 0, 0
    '  End If
    '  'Copy back buffer to main picturebox
    '  pic.PaintPicture pic.Picture, 0, 0
End Sub
Public Sub FilterBW(ByVal pic As Long, ByVal Factor As Long, ByRef pProgress As Long)
    Dim hdcNew As Long
    Dim oldhand As Long
    Dim ret As Long
    Dim BytesPerScanLine As Long
    Dim PadBytesPerScanLine As Long

    If WorkFilterG = True Then Exit Sub
    WorkFilterG = True
    'get data buffer
    Call GetObject(pic, Len(PicInfo), PicInfo)
    hdcNew = CreateCompatibleDC(0&)
    oldhand = SelectObject(hdcNew, pic)
    With DIBInfo.bmiHeader
        .biSize = 40
        .biWidth = PicInfo.bmWidth
        .biHeight = -PicInfo.bmHeight     'bottom up scan line is now inverted
        .biPlanes = 1
        .biBitCount = 32
        .biCompression = BI_RGB
        BytesPerScanLine = ((((.biWidth * .biBitCount) + 31) \ 32) * 4)
        PadBytesPerScanLine = _
        BytesPerScanLine - (((.biWidth * .biBitCount) + 7) \ 8)
        .biSizeImage = BytesPerScanLine * Abs(.biHeight)
    End With
    'redimension  (BGR+pad,x,y)
    ReDim iDATA(1 To 4, 1 To PicInfo.bmWidth, 1 To PicInfo.bmHeight) As Byte
    ReDim bDATA(1 To 4, 1 To PicInfo.bmWidth, 1 To PicInfo.bmHeight) As Byte
    'get bytes
    ret = GetDIBits(hdcNew, pic, 0, PicInfo.bmHeight, iDATA(1, 1, 1), DIBInfo, DIB_RGB_COLORS)
    ret = GetDIBits(hdcNew, pic, 0, PicInfo.bmHeight, bDATA(1, 1, 1), DIBInfo, DIB_RGB_COLORS)
    'do it
    Call FloydSteinbergBW(pProgress, Factor)

    'copy bytes to device
    ret = SetDIBits(hdcNew, pic, 0, PicInfo.bmHeight, iDATA(1, 1, 1), DIBInfo, DIB_RGB_COLORS)
    SelectObject hdcNew, oldhand
    DeleteDC hdcNew
    ReDim iDATA(1 To 4, 1 To 2, 1 To 2) As Byte
    ReDim bDATA(1 To 4, 1 To 2, 1 To 2) As Byte
    WorkFilterG = False
    Exit Sub
End Sub
Private Sub FloydSteinbergBW(ByRef pProgress As Long, ByVal PalWeight As Long)
    Dim x As Long, y As Long
    Dim r As Long, G As Long, b As Long
    Dim Erro As Long
    Dim VecErro() As Long
    Dim nCol As Long, mCol As Long
    Dim PartErr(1 To 4, -255 To 255) As Long

    For x = 0 To 765
        Speed(x) = x \ 3
    Next x
    For x = -255 To 255
        PartErr(1, x) = (7 * x) \ 16
        PartErr(2, x) = (3 * x) \ 16
        PartErr(3, x) = (5 * x) \ 16
        PartErr(4, x) = (1 * x) \ 16
    Next x
    Erro = 0
    ReDim VecErro(1 To 2, 1 To PicInfo.bmWidth) As Long
    For x = 1 To PicInfo.bmWidth
        VecErro(1, x) = 0
        VecErro(2, x) = 0
    Next x
    pProgress = 2
    DoEvents
    For y = 1 To PicInfo.bmHeight
        For x = 1 To PicInfo.bmWidth
            b = CLng(bDATA(1, x, y))
            G = CLng(bDATA(2, x, y))
            r = CLng(bDATA(3, x, y))
            b = Speed(r + G + b)
            mCol = mCol + b
            nCol = nCol + 1
        Next x
    Next y
    mCol = mCol \ nCol
    pProgress = 10
    DoEvents
    For y = 1 To PicInfo.bmHeight
        For x = 1 To PicInfo.bmWidth
            b = CLng(bDATA(1, x, y))
            G = CLng(bDATA(2, x, y))
            r = CLng(bDATA(3, x, y))
            b = Speed(r + G + b)
            b = b + (VecErro(1, x) * 10) \ PalWeight
            If b < 0 Then b = 0
            If b > 255 Then b = 255
            If b < mCol Then nCol = 0 Else nCol = 255
            iDATA(1, x, y) = nCol
            iDATA(2, x, y) = nCol
            iDATA(3, x, y) = nCol
            Erro = b - nCol
            If x < PicInfo.bmWidth Then VecErro(1, x + 1) = VecErro(1, x + 1) + PartErr(1, Erro)
            If y < PicInfo.bmHeight Then
                If x > 1 Then VecErro(2, x - 1) = VecErro(2, x - 1) + PartErr(2, Erro)
                VecErro(2, x) = VecErro(2, x) + PartErr(3, Erro)
                If x < PicInfo.bmWidth Then VecErro(2, x + 1) = VecErro(2, x + 1) + PartErr(4, Erro)
            End If
        Next x
        For x = 1 To PicInfo.bmWidth
            VecErro(1, x) = VecErro(2, x)
            VecErro(2, x) = 0
        Next x
        mProgress = 10 + (y * 90) \ PicInfo.bmHeight
        pProgress = mProgress
        DoEvents
    Next y
    pProgress = 100
    DoEvents
End Sub


